﻿-- Author      : Nogarder
-- Create Date : 2013/4/7 12:57:04
local getglobal=getglobal
local string_gmatch=string.gmatch
local tonumber=tonumber
local string_find=string.find
local pairs=pairs
local string_split=string.split
local table_getn=table.getn
local UnitName=UnitName
local next=next
--register initialize function
--NPA.DataCollector.RegisterModule( datatype, initfunc, uninitfunc )
NPA.DataCollector.RegisterModule("Quest",
	function()
		--global 
		--main --using local for speed
		local NPA_EventHandler_FireEvent=NPA.EventHandler.FireEvent
		--
		local NPA_DataCollector_QuestData={}
		local NPA_DataCollector_QuestDataCount=0
		local NPA_DataCollector_NameToQuest={}

		local FireUpdateEvent=function(framedata)
			local name=framedata.UnitData.Name
			--search every entry for name match
			for _,nametoquest in pairs(NPA_DataCollector_NameToQuest)do
				if(nametoquest.Name==name)then
					--search every quest entry for biggest remaining number
					local questlist=nametoquest.QuestList
					local best
					for _,questdata in pairs(questlist)do
						local count=questdata.Max-questdata.Current --rule out finished quest
						if(count>0 and (not best or count>best.Max-best.Current))then
							best=questdata
						end
					end
					--fire event
					framedata.QuestData=best
					NPA_EventHandler_FireEvent(8,"Quest_Updated",framedata)
					--return
					return
				end
			end
			--if no match, still fire a event ,with empty data
			framedata.QuestData=nil
			NPA_EventHandler_FireEvent(8,"Quest_Updated",framedata)
		end
		local CheckEveryFrame=function()
			for frame,framedata in pairs(NPA.NamePlate.GetFrameData())do
				if(frame:IsShown())then
					FireUpdateEvent(framedata)
				end
			end
		end
		--
		--build data when quest log updated
		NPA.EventHandler.RegisterEvent(0,"QUEST_LOG_UPDATE","DataCollector_Quest",function()
			--build quest data from quest log
			NPA_DataCollector_QuestDataCount=0
			local numQuests=GetNumQuestLogEntries()
			for index=1,numQuests do 
				--local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = GetQuestLogTitle(questID)
				local title,level,_,_,isHeader,_,isComplete=GetQuestLogTitle(index)
				if((not isHeader) and title)then--is quest entry
					local numobj=GetNumQuestLeaderBoards(index)
					if(numobj>0)then
						--split quest id, it's unique
						local _,questid=string_split(":",GetQuestLink(index),3)
						--
						for objid=1,numobj do
							local text=GetQuestLogLeaderBoard(objid,index) or ""
							for current,max in string_gmatch(text,"(%d+)/(%d+)$") do
								NPA_DataCollector_QuestDataCount=NPA_DataCollector_QuestDataCount+1
								if(not NPA_DataCollector_QuestData[NPA_DataCollector_QuestDataCount])then
									NPA_DataCollector_QuestData[NPA_DataCollector_QuestDataCount]={}
								end
								local questdata=NPA_DataCollector_QuestData[NPA_DataCollector_QuestDataCount]
								questdata.Item=text
								questdata.Current=tonumber(current)
								questdata.Max=tonumber(max)
								questdata.Name=title
								questdata.Level=level
								questdata.QuestID=questid
							end
						end
					end
				end
			end
			--clear unused name-to-quest data
			--build a quest id list
			local questidlist={}
			for i=1,NPA_DataCollector_QuestDataCount do
				questidlist[NPA_DataCollector_QuestData[i].QuestID]=true
			end
			
			for _,nametoquest in pairs(NPA_DataCollector_NameToQuest)do
				local list=nametoquest.QuestList
				for questid,_ in pairs(list)do
					if(questidlist[questid]~=true)then
						list[questid]=nil
					end
				end
				--the list is empty --clear the name
				if(not next(list))then
					nametoquest.Name=nil
				end
			end
			--fire event
			CheckEveryFrame()
		end)
		--
		NPA.EventHandler.RegisterEvent(2,"DataCollector_TooltipsUpdated","DataCollector_Quest",function(unit,lines)
			local name=UnitName(unit)
			--find or create name-to-quest match
			local nametoquest
			local list
			--
			local updated
			--search every line
			for _,line in pairs(lines)do
				if(line:IsShown())then
					local text=line:GetText()
					if(text)then
						for i=1,NPA_DataCollector_QuestDataCount do
							local questdata=NPA_DataCollector_QuestData[i]
							if(string_find(text,questdata.Item))then
								if(not nametoquest)then
									local max=table_getn(NPA_DataCollector_NameToQuest)
									for i=1,max do
										if(NPA_DataCollector_NameToQuest[i].Name==name)then
											nametoquest=NPA_DataCollector_NameToQuest[i]
											break
										end
									end
									--try using an old one if not have one
									if(not nametoquest)then
										for i=1,max do
											if(NPA_DataCollector_NameToQuest[i].Name==nil)then
												nametoquest=NPA_DataCollector_NameToQuest[i]
												nametoquest.Name=name
												break
											end
										end
										--if all used up, create a new one
										if(not nametoquest)then
											NPA_DataCollector_NameToQuest[max+1]={
												Name=name,
												QuestList={}
											}
											nametoquest=NPA_DataCollector_NameToQuest[max+1]
										end
									end
									list=nametoquest.QuestList
								end
								--check list
								if(not list[questdata.QuestID])then
									list[questdata.QuestID]=questdata
									updated=true
								end
							end
						end
					end
				end
			end
			--fire event when data changes
			if(updated)then
				CheckEveryFrame()
			end
		end)
		--fire update when name changes
		NPA.EventHandler.RegisterEvent(8,"Name_Updated","DataCollector_Quest",FireUpdateEvent)
	end,
	--------
	function()
		-------unregister all events
		NPA.EventHandler.RegisterEvent(0,"QUEST_LOG_UPDATE","DataCollector_Quest",nil)
		NPA.EventHandler.RegisterEvent(2,"DataCollector_TooltipsUpdated","DataCollector_Quest",nil)
		NPA.EventHandler.RegisterEvent(8,"Name_Updated","DataCollector_Quest",nil)
	end,
	--data transfer function,transfer frame-based unitdata to guid-based unitdata
	function(unitdata,frameunitdata)
		--do nothing
	end
	)
